/*  
 *  performance.h
  *
 *
$Log: performance.h,v $
 * Revision 2.4  1993/07/14  03:59:17  larose
 * changed bottom search subtract to "fix" scrollbars under
 * various fonts.
 *
 * Revision 2.3  1993/07/11  20:52:47  larose
 * final pre-release changes to browse & search.
 *
 * Revision 2.2  1993/07/08  03:32:53  larose
 * finally dealt a blow to the scrollbar issue.
 * >> -bl
 *
 * Revision 2.1  1993/06/16  15:03:13  wade
 * fixed minor typo
 *
 * Revision 2.0  1993/06/05  02:51:12  larose
 * THIS UN-fixes multiple scrollbars, but fixes other small things.
 *
 * Revision 1.10  1993/04/27  01:35:36  larose
 * fixed typos.
 *
 * Revision 1.9  1993/03/17  23:16:50  larose
 * modified austin to performance.cs.utk.edu so
 * that we could point to generic place.
 *
 * Revision 1.8  1993/03/06  23:30:53  larose
 * added biblio buttons.
 *
 * Revision 1.7  1993/02/02  01:24:03  larose
 * added the papers stuff for x-referencing and finding bibliographies
 * when you get numbers and want to know where they come from.
 *
 * Revision 1.6  1992/12/19  22:00:21  larose
 * lots of spelling corrections.
 * added some text descriptions.
 * changed some defines.
 *
 * Revision 1.5  1992/12/16  01:49:03  larose
 * added defines..
 *
 * Revision 1.3  1992/12/05  17:27:42  larose
 * added rcs logging
 *
 * Revision 1.2  1992/12/05  16:54:04  larose
 * added rcs logs. -brian
 *
 * 
 */


#define PERFORMANCE_SERVER  "performance.cs.utk.edu"


/* the below files drive the functioning of the browse options */
#define BENCHMARKS_FILE     "master/benchmarks"
#define VENDORS_FILE        "master/vendors"
#define PERFORMANCEDIRPATH  "/performance"


/* prolly don't wanna mess in here unless you wanna reconfigure the widgets
   layout. */
#define BUFFSIZE            2048
#define COOL_OFFSET         13
#define BUTTON_WIDTH        120 
#define BUT_HEIGHT          25 
#define SCROLLBAR           40 
#define BOX_BORDER_WIDTH    0
#define NUM_VEND            100
#define NUM_BENCH           100
#define MAX_STR_LEN         128
#define MAX_QRY_LEN         1024
#define SMALL_OFFSET        5
#define SUBVERT             140
#define SMALLVERT_OFF       140
#define SUBHORIZ            28
#define MAX_WIDGET_WIDTH    XNL_WIDTH * 20
#define MAX_WIDGET_HEIGHT   XNL_WIDTH * 20
#define TEXT_FIELD_WIDTH    250         
#define LABEL_HEIGHT        13         
#define LAB_WIDTH           75         
#define BROWSE_SUBTRACT_BOTTOM 150
#define SEARCH_SUBTRACT_BOTTOM 200

/* untouchable contstants */
#define CARR_RET            "\n"         
#define SPACES_TABS         " \t"
#define SEPCHARS            ",\"\'\n\t"
#define SEPCHARS2           " ,\"\'\n\t"
#define SPLITTER            ';'
#define ALPHA           "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890" 
#define _45_SPACES           "                                                   "

/* NON-TUNABLE DEFINES */
#define OR_SEARCH           0         
#define AND_SEARCH          1         
#define NO_RESULTS          9999         
#define FAILED              -1         
#define SUCCESS             0         


struct vendor_struct {
         char                  label[MAX_STR_LEN];
         char                  aliae[MAX_STR_LEN];
         int                   selected;
         struct vendor_struct  *next;
                     };
         
struct bench_struct {
         char                  label[MAX_STR_LEN];
         struct tablename_struct *table;
         int                   selected;
         int                   searchon;
         char                  notes[2048];
         struct bench_struct   *next;
                     };

struct tablename_struct {
         char                  name[MAX_STR_LEN];
         struct tablename_struct *next;
        };

struct bench_struct   *BENCHHEAD;
struct vendor_struct  *VENDORHEAD;

/* global uglies */
int NUM_VENS;
int PERF_UNAVAILABLE;
int PERF_MODE;

static char PERFORM_MESS[] = "\n \
\n\
             --------------------------------------------------------\n\
\n\
                    Performance Database Server  - Version 1.5\n\
\n\
                       -an extension to Xnetlib version 3.4- \n\
\n\
             --------------------------------------------------------\n\
\n\
\n\
    Rank Ordering - displays a partial list of available rank orderings\n\
                    of various machines.  This is merely a report of the\n\
                    available published benchmark numbers, which have been\n\
                    sorted by the appropriate fields.\n\
\n\
    Browse        - allows one to browse through the performance data\n\
                    tree.  This tree is stored in the same format as the\n\
                    normal library option of xnetlib.\n\
\n\
    Search        - allows one to specify search strings (keywords)\n\
                    for literal text matching.  This is similar\n\
                    to xnetlib's literal keyword search.\n\
\n\
    Save          - save the ascii window contents to a file.\n\
\n\
    Papers        - to access ASCII and postscript versions of \n\
                    the benchmark papers as contributed by the authors.\n\
\n\
    Bibliography  - to access a bibliography of benchmark and performance-\n\
                    related literature using the BibTeX format.  This \n\
                    data is contributed from various sources.\n\
\n\
  If you have comments or questions please send mail to utpds@cs.utk.edu \n\
\n\
    Thank you.\n\
\n\
\n";



static char SEARCH_INTRO_MESSAGE[] = "\n\
 #\n\
 #   Performance Database search :\n\
 #\n\
 #   To search through the performance database please enter a \n\
 #   key or series of keywords and Boolean search type.  Type <return>\n\
 #   to begin the search.\n\
 #   \n\
 #   clear display - clears the output window and prepares it for a\n\
 #                   new search result.\n\
 #   \n\
 #   clear search field - resets the search string to null.\n\
 #   \n\
 #   Search information::\n\
 #   truly a literal search over all the data.  By selecting 'and' the\n\
 #   return results are ONLY records matching ALL keys.  In selecting\n\
 #   'or' the return results are ANY records matching ANY key. \n\
 #   \n\
 # Please NOTE: The search facility allows users to BUILD up query results \n\
 #              from numerous queries in the same screen and then save them.\n\
 #              To clear the search results select 'clear display'.\n\
 #  \n\
 #";

static char BROWSE_WELCOME_MESS[] = "\
 #       Please select vendor(s) and benchmark(s) and then [Process] to view.";
